[ARX]如何得到当前CAD打印设备列表及其他打印设置内容

来源:互联网 发布:最好的期货软件 知乎 编辑:程序博客网 时间:2024/05/01 13:02
#include "dblayout.h"
#include 
"acaplmgr.h"
#include 
"dbplotsetval.h"
#include 
"dbplotsettings.h"

/*
To query the all the available plot configurations you should use plotDeviceList() 
method of AcDbPlotSettingsValidator class. 
And to get the list of available media names for a given plot configuration, 
use canonicalMediaNameList() method AcDbPlotSettingsValidator class. 
But note the media names may not be same as listed in the Plot dialog. 
So to get the media name as listed in the drop down list, 
supply the media name to the function getLocaleMediaName().

  The sample code below lists the available plot configurations and asks the user to select one. 
  After user enters his choice, all the available media are listed and user can select one to set it current. 
  Please use ObjectARX Wizard to create an ARX project and call the function () from a user defined function. 
  Make sure that you are *not* registering the command using ACRX_CMD_SESSION.

*/

// This is command 'MPLOTS'
void mplotzzmplots()
{
    AcApLayoutManager 
*pLayMan = NULL;
    pLayMan 
= (AcApLayoutManager *) acdbHostApplicationServices()->layoutManager();
    
    
//get the active layout
    AcDbLayout *pLayout = pLayMan->findLayoutNamed(pLayMan->findActiveLayout(TRUE),TRUE);
    
    AcDbPlotSettings
* pPlotSetting = (AcDbPlotSettings*)pLayout;
    
char* mediaName;
    pPlotSetting
->getCanonicalMediaName(mediaName);
    acutPrintf(
" Media Name:%s", mediaName);
    
    
char* styleSheetName;
    pPlotSetting
->getCurrentStyleSheet(styleSheetName);
    acutPrintf(
" StyleSheet Name:%s", styleSheetName);

    
char* plotCfgname;
    pPlotSetting
->getPlotCfgName(plotCfgname);          // Output pointer to name of configured system or PC3 plot device
    acutPrintf(" PlotCfg Name:%s", plotCfgname);
    
    
//get the PlotSettingsValidator
    AcDbPlotSettingsValidator *pPSV =NULL;
    pPSV 
= acdbHostApplicationServices()->plotSettingsValidator();
    
//refresh the Plot Config list
    pPSV->refreshLists(pLayout);
    
    
//get all the Plot Configurations
    AcArray< const char * > mDeviceList;
    pPSV
->plotDeviceList(mDeviceList);
    
    acutPrintf(
" Plot Configuration List :");
    
int nLength = mDeviceList.length();
    
    
char* localeName;
    pPSV
->getLocaleMediaName(pLayout, 0, localeName);
    acutPrintf(
" Cur Midia Name:%s", localeName);
    
    pPlotSetting
->close();
    pLayout
->close();

    
return;
    
for(int nCtr = 0;nCtr < nLength; nCtr++)
    
{
        acutPrintf(
"  %i) - %s",(nCtr + 1), mDeviceList.at(nCtr));
    }

    
    
//get the user input for listing the Media Names
    int nSel;
    
int mRes =  RTNONE;
    
    
while(RTNORM != mRes)
    
{
        acedInitGet((RSG_NONULL 
+ RSG_NONEG + RSG_NOZERO),NULL);
        mRes 
= acedGetInt(" Select the Plot Configuration number to list the Media names: "&nSel);
        
if (nSel > nLength) 
        
{
            acutPrintf(
" Enter a number between 1 to %i",nLength);
            mRes 
= RTNONE;
        }

    }

    
    
//select the selected Plot configuration
    pPSV->setPlotCfgName(pLayout,mDeviceList.at(--nSel));
    
//list all the paper sizes in the given Plot configuration
    AcArray< const char * > mMediaList;
    
const char *pLocaleName;
    pPSV
->canonicalMediaNameList(pLayout,mMediaList);
    
    acutPrintf(
" Media list for Plot Configuration - %s:",mDeviceList.at(nSel));
    
    nLength 
= mMediaList.length();
    
for(nCtr = 0;nCtr < nLength; nCtr++)
    
{
        
//get the localename
        pPSV->getLocaleMediaName(pLayout,mMediaList.at(nCtr),pLocaleName);
        acutPrintf(
"  %i)    Name:  %s     Locale Name: %s ",(nCtr + 1),mMediaList.at(nCtr),pLocaleName);
    }

    mRes 
=  RTNONE;
    
while(RTNORM != mRes)
    
{
        acedInitGet((RSG_NONULL 
+ RSG_NONEG + RSG_NOZERO),NULL);
        mRes 
= acedGetInt(" Select the Media by entering the number: "&nSel);
        
if (nSel > nLength) 
        
{
            acutPrintf(
" Enter a number between 1 to %i",nLength);
            mRes 
= RTNONE;
        }

    }

    
//set selected Media for the layout
    pPSV->setCanonicalMediaName(pLayout,mMediaList.at(--nSel));
    pLayout
->close();
}